package main

import (
	"encoding/json"
	"encoding/base64"
	"strconv"
	"time"
	"crypto/md5"
	"io"
	"fmt"
	"net/http"
	"net/url"
	"strings"
	"io/ioutil"
)

func natural_language() {
	appid := "******"
	apikey := "***********"
	post_url := "http://ltpapi.xfyun.cn/v1/cws"
	curtime := strconv.FormatInt(time.Now().Unix(), 10)

	param := make(map[string]string)
	param["type"] = "dependent"
	tmp, _ := json.Marshal(param)
	base64_param := base64.StdEncoding.EncodeToString(tmp)

	w := md5.New()
	io.WriteString(w, apikey+curtime+base64_param)
	checksum := fmt.Sprintf("%x", w.Sum(nil))

	data := url.Values{}
	data.Add("text", "我今天很开心")
	body := data.Encode()

	client := &http.Client{}
	req, _ := http.NewRequest("POST", post_url, strings.NewReader(body))
	req.Header.Set("X-Appid", appid)
	req.Header.Set("X-CurTime", curtime)
	req.Header.Set("X-Param", base64_param)
	req.Header.Set("X-CheckSum", checksum)
	req.Header.Set("Content-Type", "application/x-www-form-urlencoded")

	res, _ := client.Do(req)
	defer res.Body.Close()
	res_body, _ := ioutil.ReadAll(res.Body)
	fmt.Print(string(res_body))
}

func main() {
	natural_language()
}
